{% extends "stigapp/base.html" %}
{% load static %}

{% block content %}
    {% if user.is_authenticated %}
        {% if user.is_staff or user.is_admin %}
            <div class="row">
                <div class="col-6">
                    <h2>Garden Message List</h2>
                </div>

                <div class="col-1">
                    <a href='{% url "export_gardenmessage" %}'>
                        <button type="button" class="btn btn-secondary btn-sm">
                            Export CSV
                        </button>
                    </a>
                </div>
            </div>

            <table class="table">
                <thead>
                    <tr class="table-success">
                        <th scope="col">Author</th>
                        <th scope="col">Twitter Handle</th>
                        <th scope="col">Message ID</th>
                        <th scope="col">Original Message</th>
                        <th scope="col">Editable Message</th>
                        <th scope="col">Edited At</th>
                        <th scope="col">All Reactions</th>
                        <th scope="col">Unique Reactions</th>
                        <th scope="col">All Emojis</th>
                        <th scope="col">Unique Emojis</th>
                        <th scope="col">Totals by Emoji</th>
                        <th scope="col">Total Users</th>
                        <th scope="col">Unique Users</th>
                        <th scope="col">Total User List</th>
                        <th scope="col">Unique User List</th>
                        <th scope="col">Exported At</th>
                    </tr>
                </thead>
                <tbody>
                    {% for message in gardenmessage_list %}
                        <tr>
                            <td>{{ message.author_discord_username }}</td>
                            <td>{{ message.twitter_handle }}</td>
                            <td>
                                {% if message.jump_url == None %}
                                    {{ message.message_id }}
                                {% else %}
                                    <a href="{{message.jump_url}}" target="_blank">
                                        {{ message.message_id }}
                                    </a>
                                {% endif %}
                            </td>
                            <td>{{ message.original_message }}</td>
                            <td>{{ message.editable_message }}</td>
                            <td>{{ message.edited_at }}</td>
                            <td>{{ message.reaction_count }}</td>
                            <td>{{ message.unique_reaction_count }}</td>
                            <td>
                                {% for emoji in message.emoji_list %}
                                    {{emoji}}
                                {% endfor %}
                            </td>
                            <td>
                                {% for emoji in message.unique_emoji_list %}
                                    {{emoji}}
                                {% endfor %}
                            </td>
                            <td>
                                {% for emoji in message.counts_by_emoji %}
                                    <p>{{emoji}}: {{message.counts_by_emoji|dict_key:emoji}}</p>
                                {% endfor %}
                            </td>
                            <td>{{ message.user_count }}</td>
                            <td>{{ message.unique_user_count }}</td>
                            <td>
                                {% for user in message.user_list %}
                                    {{ user.name }}{{ user.discriminator }},
                                {% endfor %}
                            </td>
                            <td>
                                {% for user in message.unique_user_list %}
                                    {{ user.name }}{{ user.discriminator }},
                                {% endfor %}
                            </td>
                            <td>{{ message.exported_at }}</td>
                        </tr>
                    {% endfor %}
                </tbody>
            </table>

            <br />
            <br />
            <br />



            <div class="row">
                <div class="col-6">
                    <h2>Top Message List</h2>
                </div>

                <div class="col-4">
                    <a href='{% url "update_topmessage" %}'>
                        <button type="button" class="btn btn-primary btn-sm">
                            Update List
                        </button>
                    </a>

                    <a href='{% url "export_topmessage" %}'>
                        <button type="button" class="btn btn-secondary btn-sm">
                            Export CSV
                        </button>
                    </a>
                </div>
            </div>

            <table class="table">
                <thead>
                    <tr class="table-success">
                        <th scope="col">Author</th>
                        <th scope="col">Message ID</th>
                        <th scope="col">Message</th>
                        <th scope="col">All Reactions</th>
                        <th scope="col">Unique Reactions</th>
                        <th scope="col">All Emojis</th>
                        <th scope="col">Unique Emojis</th>
                        <th scope="col">Totals by Emoji</th>
                        <th scope="col">Total Users</th>
                        <th scope="col">Unique Users</th>
                        <th scope="col">Total User List</th>
                        <th scope="col">Unique User List</th>
                        <th scope="col">Added to Garden</th>
                        <th scope="col">Exported At</th>
                    </tr>
                </thead>
                <tbody>
                    {% for message in topmessage_list %}
                        <tr>
                            <td>{{ message.author_discord_username }}</td>
                            <td>
                                {% if message.jump_url == None %}
                                    {{ message.message_id }}
                                {% else %}
                                    <a href="{{message.jump_url}}" target="_blank">
                                        {{ message.message_id }}
                                    </a>
                                {% endif %}
                            </td>
                            <td>{{ message.original_message }}</td>

                            <td>{{ message.reaction_count }}</td>
                            <td>{{ message.unique_reaction_count }}</td>
                            <td>
                                {% for emoji in message.emoji_list %}
                                    {{emoji}}
                                {% endfor %}
                            </td>
                            <td>
                                {% for emoji in message.unique_emoji_list %}
                                    {{emoji}}
                                {% endfor %}
                            </td>
                            <td>
                                {% for emoji in message.counts_by_emoji %}
                                    <p>{{emoji}}: {{message.counts_by_emoji|dict_key:emoji}}</p>
                                {% endfor %}
                            </td>
                            <td>{{ message.user_count }}</td>
                            <td>{{ message.unique_user_count }}</td>
                            <td>
                                {% for user in message.user_list %}
                                    {{ user.name }}{{ user.discriminator }},
                                {% endfor %}
                            </td>
                            <td>
                                {% for user in message.unique_user_list %}
                                    {{ user.name }}{{ user.discriminator }},
                                {% endfor %}
                            </td>
                            <td>{{ message.added_to_garden }}</td>
                            <td>{{ message.exported_at }}</td>
                        </tr>
                    {% endfor %}
                </tbody>
            </table>

        {% endif %}
    {% endif %}
{% endblock content %}
